	component pcie_ed_BAR_INTERPRETER is
		port (
			Clk_i                       : in  std_logic                      := 'X';             -- clk
			Rstn_i                      : in  std_logic                      := 'X';             -- reset_n
			bri_s_address_i             : in  std_logic_vector(15 downto 0)  := (others => 'X'); -- address
			bri_s_byteenable_i          : in  std_logic_vector(63 downto 0)  := (others => 'X'); -- byteenable
			bri_s_read_i                : in  std_logic                      := 'X';             -- read
			bri_s_readdata_o            : out std_logic_vector(511 downto 0);                    -- readdata
			bri_s_readdatavalid_o       : out std_logic;                                         -- readdatavalid
			bri_s_write_i               : in  std_logic                      := 'X';             -- write
			bri_s_writedata_i           : in  std_logic_vector(511 downto 0) := (others => 'X'); -- writedata
			bri_s_burstcount_i          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- burstcount
			bri_s_waitrequest_o         : out std_logic;                                         -- waitrequest
			bri_s_response_o            : out std_logic_vector(1 downto 0);                      -- response
			bri_s_writeresponse_valid_o : out std_logic;                                         -- writeresponsevalid
			bri_m_address_o             : out std_logic_vector(19 downto 0);                     -- address
			bri_m_read_o                : out std_logic;                                         -- read
			bri_m_readdata_i            : in  std_logic_vector(511 downto 0) := (others => 'X'); -- readdata
			bri_m_readdatavalid_i       : in  std_logic                      := 'X';             -- readdatavalid
			bri_m_write_o               : out std_logic;                                         -- write
			bri_m_writedata_o           : out std_logic_vector(511 downto 0);                    -- writedata
			bri_m_waitrequest_i         : in  std_logic                      := 'X';             -- waitrequest
			bri_m_byteenable_o          : out std_logic_vector(63 downto 0);                     -- byteenable
			bri_m_response_i            : in  std_logic_vector(1 downto 0)   := (others => 'X'); -- response
			bri_m_burstcount_o          : out std_logic_vector(3 downto 0);                      -- burstcount
			bri_s_bar_i                 : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- barnum
			bri_s_pfnum_i               : in  std_logic_vector(1 downto 0)   := (others => 'X')  -- pfnum
		);
	end component pcie_ed_BAR_INTERPRETER;

	u0 : component pcie_ed_BAR_INTERPRETER
		port map (
			Clk_i                       => CONNECTED_TO_Clk_i,                       --         clk.clk
			Rstn_i                      => CONNECTED_TO_Rstn_i,                      --       reset.reset_n
			bri_s_address_i             => CONNECTED_TO_bri_s_address_i,             --   bri_slave.address
			bri_s_byteenable_i          => CONNECTED_TO_bri_s_byteenable_i,          --            .byteenable
			bri_s_read_i                => CONNECTED_TO_bri_s_read_i,                --            .read
			bri_s_readdata_o            => CONNECTED_TO_bri_s_readdata_o,            --            .readdata
			bri_s_readdatavalid_o       => CONNECTED_TO_bri_s_readdatavalid_o,       --            .readdatavalid
			bri_s_write_i               => CONNECTED_TO_bri_s_write_i,               --            .write
			bri_s_writedata_i           => CONNECTED_TO_bri_s_writedata_i,           --            .writedata
			bri_s_burstcount_i          => CONNECTED_TO_bri_s_burstcount_i,          --            .burstcount
			bri_s_waitrequest_o         => CONNECTED_TO_bri_s_waitrequest_o,         --            .waitrequest
			bri_s_response_o            => CONNECTED_TO_bri_s_response_o,            --            .response
			bri_s_writeresponse_valid_o => CONNECTED_TO_bri_s_writeresponse_valid_o, --            .writeresponsevalid
			bri_m_address_o             => CONNECTED_TO_bri_m_address_o,             --  bri_master.address
			bri_m_read_o                => CONNECTED_TO_bri_m_read_o,                --            .read
			bri_m_readdata_i            => CONNECTED_TO_bri_m_readdata_i,            --            .readdata
			bri_m_readdatavalid_i       => CONNECTED_TO_bri_m_readdatavalid_i,       --            .readdatavalid
			bri_m_write_o               => CONNECTED_TO_bri_m_write_o,               --            .write
			bri_m_writedata_o           => CONNECTED_TO_bri_m_writedata_o,           --            .writedata
			bri_m_waitrequest_i         => CONNECTED_TO_bri_m_waitrequest_i,         --            .waitrequest
			bri_m_byteenable_o          => CONNECTED_TO_bri_m_byteenable_o,          --            .byteenable
			bri_m_response_i            => CONNECTED_TO_bri_m_response_i,            --            .response
			bri_m_burstcount_o          => CONNECTED_TO_bri_m_burstcount_o,          --            .burstcount
			bri_s_bar_i                 => CONNECTED_TO_bri_s_bar_i,                 -- bri_conduit.barnum
			bri_s_pfnum_i               => CONNECTED_TO_bri_s_pfnum_i                --            .pfnum
		);

