	component pcie_ed_DMA_CONTROLLER is
		port (
			Clk_i                 : in  std_logic                      := 'X';             -- clk
			Rstn_i                : in  std_logic                      := 'X';             -- reset_n
			dma_s_address_i       : in  std_logic_vector(11 downto 0)  := (others => 'X'); -- address
			dma_s_read_i          : in  std_logic                      := 'X';             -- read
			dma_s_readdata_o      : out std_logic_vector(511 downto 0);                    -- readdata
			dma_s_readdatavalid_o : out std_logic;                                         -- readdatavalid
			dma_s_write_i         : in  std_logic                      := 'X';             -- write
			dma_s_writedata_i     : in  std_logic_vector(511 downto 0) := (others => 'X'); -- writedata
			dma_s_waitrequest_o   : out std_logic;                                         -- waitrequest
			dma_s_byteenable_i    : in  std_logic_vector(63 downto 0)  := (others => 'X'); -- byteenable
			dma_s_response_o      : out std_logic_vector(1 downto 0);                      -- response
			dma_s_burstcount_i    : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- burstcount
			dma_wrdm_pfnum_i      : in  std_logic_vector(1 downto 0)   := (others => 'X'); -- pfnum
			dma_wrdm_desc_ready_i : in  std_logic                      := 'X';             -- ready
			dma_wrdm_desc_valid_o : out std_logic;                                         -- valid
			dma_wrdm_desc_data_o  : out std_logic_vector(173 downto 0);                    -- data
			dma_wrdm_prio_ready_i : in  std_logic                      := 'X';             -- ready
			dma_wrdm_prio_valid_o : out std_logic;                                         -- valid
			dma_wrdm_prio_data_o  : out std_logic_vector(173 downto 0);                    -- data
			dma_wrdm_tx_valid_i   : in  std_logic                      := 'X';             -- valid
			dma_wrdm_tx_data_i    : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- data
			dma_rddm_pfnum_i      : in  std_logic_vector(1 downto 0)   := (others => 'X'); -- pfnum
			dma_rddm_desc_ready_i : in  std_logic                      := 'X';             -- ready
			dma_rddm_desc_valid_o : out std_logic;                                         -- valid
			dma_rddm_desc_data_o  : out std_logic_vector(173 downto 0);                    -- data
			dma_rddm_prio_ready_i : in  std_logic                      := 'X';             -- ready
			dma_rddm_prio_valid_o : out std_logic;                                         -- valid
			dma_rddm_prio_data_o  : out std_logic_vector(173 downto 0);                    -- data
			dma_rddm_tx_valid_i   : in  std_logic                      := 'X';             -- valid
			dma_rddm_tx_data_i    : in  std_logic_vector(31 downto 0)  := (others => 'X')  -- data
		);
	end component pcie_ed_DMA_CONTROLLER;

	u0 : component pcie_ed_DMA_CONTROLLER
		port map (
			Clk_i                 => CONNECTED_TO_Clk_i,                 --          clk.clk
			Rstn_i                => CONNECTED_TO_Rstn_i,                --        reset.reset_n
			dma_s_address_i       => CONNECTED_TO_dma_s_address_i,       --    dma_slave.address
			dma_s_read_i          => CONNECTED_TO_dma_s_read_i,          --             .read
			dma_s_readdata_o      => CONNECTED_TO_dma_s_readdata_o,      --             .readdata
			dma_s_readdatavalid_o => CONNECTED_TO_dma_s_readdatavalid_o, --             .readdatavalid
			dma_s_write_i         => CONNECTED_TO_dma_s_write_i,         --             .write
			dma_s_writedata_i     => CONNECTED_TO_dma_s_writedata_i,     --             .writedata
			dma_s_waitrequest_o   => CONNECTED_TO_dma_s_waitrequest_o,   --             .waitrequest
			dma_s_byteenable_i    => CONNECTED_TO_dma_s_byteenable_i,    --             .byteenable
			dma_s_response_o      => CONNECTED_TO_dma_s_response_o,      --             .response
			dma_s_burstcount_i    => CONNECTED_TO_dma_s_burstcount_i,    --             .burstcount
			dma_wrdm_pfnum_i      => CONNECTED_TO_dma_wrdm_pfnum_i,      -- wrdm_conduit.pfnum
			dma_wrdm_desc_ready_i => CONNECTED_TO_dma_wrdm_desc_ready_i, --    wrdm_desc.ready
			dma_wrdm_desc_valid_o => CONNECTED_TO_dma_wrdm_desc_valid_o, --             .valid
			dma_wrdm_desc_data_o  => CONNECTED_TO_dma_wrdm_desc_data_o,  --             .data
			dma_wrdm_prio_ready_i => CONNECTED_TO_dma_wrdm_prio_ready_i, --    wrdm_prio.ready
			dma_wrdm_prio_valid_o => CONNECTED_TO_dma_wrdm_prio_valid_o, --             .valid
			dma_wrdm_prio_data_o  => CONNECTED_TO_dma_wrdm_prio_data_o,  --             .data
			dma_wrdm_tx_valid_i   => CONNECTED_TO_dma_wrdm_tx_valid_i,   --      wrdm_tx.valid
			dma_wrdm_tx_data_i    => CONNECTED_TO_dma_wrdm_tx_data_i,    --             .data
			dma_rddm_pfnum_i      => CONNECTED_TO_dma_rddm_pfnum_i,      -- rddm_conduit.pfnum
			dma_rddm_desc_ready_i => CONNECTED_TO_dma_rddm_desc_ready_i, --    rddm_desc.ready
			dma_rddm_desc_valid_o => CONNECTED_TO_dma_rddm_desc_valid_o, --             .valid
			dma_rddm_desc_data_o  => CONNECTED_TO_dma_rddm_desc_data_o,  --             .data
			dma_rddm_prio_ready_i => CONNECTED_TO_dma_rddm_prio_ready_i, --    rddm_prio.ready
			dma_rddm_prio_valid_o => CONNECTED_TO_dma_rddm_prio_valid_o, --             .valid
			dma_rddm_prio_data_o  => CONNECTED_TO_dma_rddm_prio_data_o,  --             .data
			dma_rddm_tx_valid_i   => CONNECTED_TO_dma_rddm_tx_valid_i,   --      rddm_tx.valid
			dma_rddm_tx_data_i    => CONNECTED_TO_dma_rddm_tx_data_i     --             .data
		);

