
namespace eval pcie_ed_dut {
  proc get_design_libraries {} {
    set libraries [dict create]
    dict set libraries altera_iopll_2000               1
    dict set libraries intel_pcie_ptile_ast_922        1
    dict set libraries intelclkctrl_201                1
    dict set libraries intel_pcie_ptile_avmm_dcore_100 1
    dict set libraries intel_pcie_ptile_avmm_401       1
    dict set libraries pcie_ed_dut                     1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set memory_files [list]
    return $memory_files
  }
  
  proc get_common_design_files {QSYS_SIMDIR} {
    set design_files [dict create]
    return $design_files
  }
  
  proc get_design_files {QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set design_files [list]
    lappend design_files "-makelib altera_iopll_2000 \"[normalize_path "$QSYS_SIMDIR/../altera_iopll_2000/sim/pcie_ed_dut_altera_iopll_2000_l55o6ui.vo"]\"   -end"                                                                               
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intel_ptile_io_pll_250.v"]\"   -end"                                                                                 
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/pcie_ed_dut_intel_pcie_ptile_ast_922_r6eeyuq.sv"]\"   -end"                                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/soft_logic_interfaces.sv"]\"   -end"                                                                                 
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/pcie_wrapper.sv"]\"   -end"                                                                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/altera_std_synchronizer_nocut.v"]\"   -end"                                                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/ptile_pcie_adapter_wrapper.sv"]\"   -end"                                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/pcie_cii_ari_decode.sv"]\"   -end"                                                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/pcie_cii_10bit_tag.sv"]\"   -end"                                                              
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/pcie_cii_workaround.sv"]\"   -end"                                                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/phy_user_avmm_arb.sv"]\"   -end"                                                               
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/ptile_rst_seq.sv"]\"   -end"                                                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/ptile_pcie_soft_glue.sv"]\"   -end"                                                            
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/ptile_pcie_user_avmm_adapter.sv"]\"   -end"                                                    
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/ptile_prs_soft_logic.sv"]\"   -end"                                                            
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/whr_rx_deskew.sv"]\"   -end"                                                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/whr_tx_deskew.sv"]\"   -end"                                                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/wrlib_rx_aib_deskew.sv"]\"   -end"                                                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/wrlib_rx_aib_deskew_datapipe.sv"]\"   -end"                                                    
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/wrlib_rx_aib_deskew_sm.sv"]\"   -end"                                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/wrlib_ecc_dec_c78_d70.sv"]\"   -end"                                                           
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/whr_ecc_chk_deskew_top.sv"]\"   -end"                                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/whr_ecc_gen_top.sv"]\"   -end"                                                                 
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/wrlib_ecc_enc_d70_c78.sv"]\"   -end"                                                           
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/gf_clkmux.sv"]\"   -end"                                                                       
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/soft_logics/pcie_decremental_cdt_wa.sv"]\"   -end"                                                         
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/sngl_seg/intel_pcie_adapter_rx_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/sngl_seg/intel_pcie_adapter_tx_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/sngl_seg/intel_pcie_adapter_stos.sv"]\"   -end"                                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_adapter.sv"]\"   -end"                                                 
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_cfg_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_cii_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_credit_if.sv"]\"   -end"                                               
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_dcfifo.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_error_if.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_flr_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_gpx3.sv"]\"   -end"                                                    
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_hard_ip_status_if.sv"]\"   -end"                                       
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_hot_plug_if.sv"]\"   -end"                                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_int_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_pm_if.sv"]\"   -end"                                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_prs_if.sv"]\"   -end"                                                  
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_rx_st_if.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_sync_bit.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_sync_pulse.sv"]\"   -end"                                              
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_sync_vec.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_tx_st_if.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8/intel_pcie_whr_gen4x8_vferr_if.sv"]\"   -end"                                                
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_adapter.sv"]\"   -end"                                       
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_cfg_if.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_cii_if.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_credit_if.sv"]\"   -end"                                     
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_dcfifo.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_error_if.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_flr_if.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_gpx3.sv"]\"   -end"                                          
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_hard_ip_status_if.sv"]\"   -end"                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_hot_plug_if.sv"]\"   -end"                                   
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_int_if.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_pm_if.sv"]\"   -end"                                         
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_prs_if.sv"]\"   -end"                                        
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_rx_st_if.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_sync_bit.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_sync_pulse.sv"]\"   -end"                                    
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_sync_vec.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/g4x8_avmm/intel_pcie_whr_gen4x8_avmm_tx_st_if.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/adapters/adapter_common/alt_mlab.v"]\"   -end"                                                             
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_addrdc.v"]\"   -end"                                                              
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_rdwr_ctrl.v"]\"   -end"                                                           
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_cfgmnt.v"]\"   -end"                                                              
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_cap_pfvfreg.v"]\"   -end"                                                         
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_cfg_access_cap.v"]\"   -end"                                                      
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_dataflow.v"]\"   -end"                                                            
    lappend design_files "-makelib intel_pcie_ptile_ast_922 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_ast_922/sim/intelfpga/virtio/intel_pcie_virtio_top.v"]\"   -end"                                                                 
    lappend design_files "-makelib intelclkctrl_201 \"[normalize_path "$QSYS_SIMDIR/../intelclkctrl_201/sim/pcie_ed_dut_intelclkctrl_201_2iresly.v"]\"   -end"                                                                                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pio_clkCtrl.v"]\"   -end"                                                                        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_512.sv"]\"   -end"                                                         
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_lite_master.sv"]\"   -end"                                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam.sv"]\"   -end"                                          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam_avmm_intf.sv"]\"   -end"                                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam_cpl.sv"]\"   -end"                                      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam_fifos.sv"]\"   -end"                                    
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam_rw.sv"]\"   -end"                                       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intel_pcie_ptile_avmm_dcore_bam/intel_pcie_bam_sch_intf.sv"]\"   -end"                                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm/intel_pcie_rddm.sv"]\"   -end"                              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm/intel_pcie_rddm_desc_preproc.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm/intel_pcie_rddm_desc_queue.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm/intel_pcie_rddm_cpl.sv"]\"   -end"                          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm/intel_pcie_rddm_header_gen.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_2.sv"]\"   -end"                    
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_cpl_2.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_cpl_cmd_2.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_cpl_data_2.sv"]\"   -end"           
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_desc_preproc_2.sv"]\"   -end"       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_header_gen_2.sv"]\"   -end"         
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_rdmaster_2.sv"]\"   -end"           
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/intel_pcie_rddm_tagram_2.sv"]\"   -end"             
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/altera_pcie_s10_fifo.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_rddm_ext_tag/altera_pcie_s10_sclkfifo.sv"]\"   -end"             
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_avmm_translator_512.sv"]\"   -end"               
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_60bit_adder.sv"]\"   -end"                       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_pipelined_57_6_adder.sv"]\"   -end"              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_write_data_mover_512.sv"]\"   -end"              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_wdm_input_stage_512.sv"]\"   -end"               
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_wdm_destn_address_generator.sv"]\"   -end"       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_shallow_fifo.sv"]\"   -end"                      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_wdm_avmm_sm_512.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_wdm_packet_generator_512.sv"]\"   -end"          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_62bit_adder.sv"]\"   -end"                       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_sclkfifo.sv"]\"   -end"                          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_wrdm/intel_pcie_wdm_data_aligner.sv"]\"   -end"                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_bas/intel_pcie_bas.sv"]\"   -end"                                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_bas/intel_pcie_lite_bas.sv"]\"   -end"                           
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_hip_intf/intel_pcie_rxpkt_221.sv"]\"   -end"                     
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_hip_intf/intel_pcie_pnp_req_mux.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_hip_intf/intel_pcie_hip_intf.sv"]\"   -end"                      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_cs/intel_pcie_cs.sv"]\"   -end"                                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/intel_pcie_schd.sv"]\"   -end"                              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx.sv"]\"   -end"                        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_cdt_handler.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_ibuf.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_ibuf_rd_dns.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_obuf_order_mngr.sv"]\"   -end"        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_parser.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_bam_cdt_checker.sv"]\"   -end"        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_delay.sv"]\"   -end"                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_ibuf_order_mngr.sv"]\"   -end"        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_obuf.sv"]\"   -end"                   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_p_np_arb.sv"]\"   -end"               
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/rx/intel_pcie_schd_rx_stream.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx.sv"]\"   -end"                        
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_np_obuf.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_ibuf.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_order_mngr.sv"]\"   -end"          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_packer.sv"]\"   -end"              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_cdt_checker.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_np_order_mngr.sv"]\"   -end"          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_np_arb.sv"]\"   -end"              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_order_mngr_rd.sv"]\"   -end"       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_seg_packer_4_to_2.sv"]\"   -end"      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_invalidator.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_np_packer.sv"]\"   -end"              
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_obuf.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/tx/intel_pcie_schd_tx_pc_order_mngr_wr.sv"]\"   -end"       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/common/intel_pcie_schd_order.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/common/intel_pcie_schd_piped_empty_calc.sv"]\"   -end"      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_schd/common/intel_pcie_schd_scfifo.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_reordering/intel_pcie_order.sv"]\"   -end"                       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_reordering/intel_pcie_order_buffer.sv"]\"   -end"                
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_reordering/intel_pcie_order_read.sv"]\"   -end"                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_reordering/intel_pcie_order_rifo.sv"]\"   -end"                  
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_reordering/intel_pcie_order_write.sv"]\"   -end"                 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_completion_checker.sv"]\"   -end"          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_completion_timeout_detection.sv"]\"   -end"
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_completion_timeout_detector.sv"]\"   -end" 
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_completion_missing_detection.sv"]\"   -end"
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_completion_error_handling.sv"]\"   -end"   
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_completion/intel_pcie_config_extractor.sv"]\"   -end"            
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_common/intel_pcie_lut_ram.sv"]\"   -end"                         
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_common/intel_pcie_ram.sv"]\"   -end"                             
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_common/intel_pcie_scfifo.sv"]\"   -end"                          
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_common/intel_pcie_scfifo_32.sv"]\"   -end"                       
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_ptile_avmm_dcore_common/intel_pcie_set_clr_rd.sv"]\"   -end"                      
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_lite_avmm_bridge_512_dcore.sv"]\"   -end"                                         
    lappend design_files "-makelib intel_pcie_ptile_avmm_dcore_100 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_dcore_100/sim/intelfpga/intel_pcie_avmm_bridge_512_dcore.sv"]\"   -end"                                              
    lappend design_files "-makelib intel_pcie_ptile_avmm_401 \"[normalize_path "$QSYS_SIMDIR/../intel_pcie_ptile_avmm_401/sim/pcie_ed_dut_intel_pcie_ptile_avmm_401_jy3nsei.v"]\"   -end"                                                        
    lappend design_files "-makelib pcie_ed_dut \"[normalize_path "$QSYS_SIMDIR/pcie_ed_dut.v"]\"   -end"                                                                                                                                         
    return $design_files
  }
  
  proc get_non_duplicate_elab_option {ELAB_OPTIONS NEW_ELAB_OPTION} {
    set IS_DUPLICATE [string first $NEW_ELAB_OPTION $ELAB_OPTIONS]
    if {$IS_DUPLICATE == -1} {
      return $NEW_ELAB_OPTION
    } else {
      return ""
    }
  }
  
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc normalize_path {FILEPATH} {
      if {[catch { package require fileutil } err]} { 
          return $FILEPATH 
      } 
      set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
      if {[file pathtype $FILEPATH] eq "relative"} { 
          set path [fileutil::relative [pwd] $path] 
      } 
      return $path 
  } 
  proc get_dpi_libraries {QSYS_SIMDIR} {
    set libraries [dict create]
    
    return $libraries
  }
  
}
