source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_resetIP/sim/common/vcs_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_MEM0/sim/common/vcs_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/common/vcs_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_dut/sim/common/vcs_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/common/vcs_files.tcl]

namespace eval pcie_ed {
  proc get_memory_files {QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set memory_files [list]
    set memory_files [concat $memory_files [pcie_ed_resetIP::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_MEM0::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_DMA_CONTROLLER::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_dut::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_BAR_INTERPRETER::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/" "$QUARTUS_INSTALL_DIR"]]
    return $memory_files
  }
  
  proc get_common_design_files {QSYS_SIMDIR} {
    set design_files [dict create]
    set design_files [dict merge $design_files [pcie_ed_resetIP::get_common_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_MEM0::get_common_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_DMA_CONTROLLER::get_common_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_dut::get_common_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_BAR_INTERPRETER::get_common_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/"]]
    return $design_files
  }
  
  proc get_design_files {QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set design_files [dict create]
    set design_files [dict merge $design_files [pcie_ed_resetIP::get_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [dict merge $design_files [pcie_ed_MEM0::get_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [dict merge $design_files [pcie_ed_DMA_CONTROLLER::get_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [dict merge $design_files [pcie_ed_dut::get_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [dict merge $design_files [pcie_ed_BAR_INTERPRETER::get_design_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/" "$QUARTUS_INSTALL_DIR"]]
    dict set design_files "pcie_ed_altera_merlin_master_translator_193_gqdbrbq.sv"                     "$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_gqdbrbq.sv"                   
    dict set design_files "pcie_ed_altera_merlin_master_translator_193_hjlcphy.sv"                     "$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_hjlcphy.sv"                   
    dict set design_files "pcie_ed_altera_merlin_slave_translator_191_xg7rzxi.sv"                      "$QSYS_SIMDIR/../altera_merlin_slave_translator_191/sim/pcie_ed_altera_merlin_slave_translator_191_xg7rzxi.sv"                     
    dict set design_files "pcie_ed_altera_merlin_master_agent_1931_56t3lmi.sv"                         "$QSYS_SIMDIR/../altera_merlin_master_agent_1931/sim/pcie_ed_altera_merlin_master_agent_1931_56t3lmi.sv"                           
    dict set design_files "pcie_ed_altera_merlin_slave_agent_1930_jxauz3i.sv"                          "$QSYS_SIMDIR/../altera_merlin_slave_agent_1930/sim/pcie_ed_altera_merlin_slave_agent_1930_jxauz3i.sv"                             
    dict set design_files "altera_merlin_burst_uncompressor.sv"                                        "$QSYS_SIMDIR/../altera_merlin_slave_agent_1930/sim/altera_merlin_burst_uncompressor.sv"                                           
    dict set design_files "pcie_ed_altera_avalon_sc_fifo_1932_22gxxgi.v"                               "$QSYS_SIMDIR/../altera_avalon_sc_fifo_1932/sim/pcie_ed_altera_avalon_sc_fifo_1932_22gxxgi.v"                                      
    dict set design_files "pcie_ed_altera_merlin_router_1921_r4umyza.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_r4umyza.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_router_1921_tuh65mq.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_tuh65mq.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_router_1921_p35amvi.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_p35amvi.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_traffic_limiter_altera_avalon_sc_fifo_1921_ctvx6xa.v" "$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/pcie_ed_altera_merlin_traffic_limiter_altera_avalon_sc_fifo_1921_ctvx6xa.v"
    dict set design_files "altera_merlin_reorder_memory.sv"                                            "$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/altera_merlin_reorder_memory.sv"                                           
    dict set design_files "altera_avalon_st_pipeline_base.v"                                           "$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/altera_avalon_st_pipeline_base.v"                                          
    dict set design_files "pcie_ed_altera_merlin_traffic_limiter_1921_etfmhbi.sv"                      "$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/pcie_ed_altera_merlin_traffic_limiter_1921_etfmhbi.sv"                     
    dict set design_files "pcie_ed_altera_merlin_demultiplexer_1921_43wbivq.sv"                        "$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/pcie_ed_altera_merlin_demultiplexer_1921_43wbivq.sv"                         
    dict set design_files "pcie_ed_altera_merlin_multiplexer_1922_qq2xwja.sv"                          "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_qq2xwja.sv"                             
    dict set design_files "altera_merlin_arbitrator.sv"                                                "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv"                                                   
    dict set design_files "pcie_ed_altera_merlin_multiplexer_1922_xauqp4i.sv"                          "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_xauqp4i.sv"                             
    dict set design_files "altera_merlin_arbitrator.sv"                                                "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv"                                                   
    dict set design_files "altera_merlin_waitrequest_adapter.v"                                        "$QSYS_SIMDIR/../altera_merlin_waitrequest_adapter_1912/sim/altera_merlin_waitrequest_adapter.v"                                   
    dict set design_files "altera_avalon_sc_fifo.v"                                                    "$QSYS_SIMDIR/../altera_merlin_waitrequest_adapter_1912/sim/altera_avalon_sc_fifo.v"                                               
    dict set design_files "pcie_ed_altera_avalon_st_pipeline_stage_1930_oiupeiq.sv"                    "$QSYS_SIMDIR/../altera_avalon_st_pipeline_stage_1930/sim/pcie_ed_altera_avalon_st_pipeline_stage_1930_oiupeiq.sv"                 
    dict set design_files "altera_avalon_st_pipeline_base.v"                                           "$QSYS_SIMDIR/../altera_avalon_st_pipeline_stage_1930/sim/altera_avalon_st_pipeline_base.v"                                        
    dict set design_files "pcie_ed_altera_mm_interconnect_1920_tfv2hfa.v"                              "$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_tfv2hfa.v"                                    
    dict set design_files "pcie_ed_altera_merlin_master_translator_193_lgcew2q.sv"                     "$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_lgcew2q.sv"                   
    dict set design_files "pcie_ed_altera_merlin_router_1921_j2lddiy.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_j2lddiy.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_router_1921_yopg3ma.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_yopg3ma.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_demultiplexer_1921_msxwozy.sv"                        "$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/pcie_ed_altera_merlin_demultiplexer_1921_msxwozy.sv"                         
    dict set design_files "pcie_ed_altera_merlin_multiplexer_1922_bo7umjy.sv"                          "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_bo7umjy.sv"                             
    dict set design_files "altera_merlin_arbitrator.sv"                                                "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv"                                                   
    dict set design_files "pcie_ed_altera_merlin_multiplexer_1922_svo354y.sv"                          "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_svo354y.sv"                             
    dict set design_files "altera_merlin_arbitrator.sv"                                                "$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv"                                                   
    dict set design_files "pcie_ed_altera_mm_interconnect_1920_b4k4ufq.v"                              "$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_b4k4ufq.v"                                    
    dict set design_files "pcie_ed_altera_merlin_master_translator_193_j7dnv4i.sv"                     "$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_j7dnv4i.sv"                   
    dict set design_files "pcie_ed_altera_merlin_router_1921_xx4nuzi.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_xx4nuzi.sv"                                       
    dict set design_files "pcie_ed_altera_merlin_router_1921_2tuydyy.sv"                               "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_2tuydyy.sv"                                       
    dict set design_files "pcie_ed_altera_mm_interconnect_1920_jn5blyq.v"                              "$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_jn5blyq.v"                                    
    dict set design_files "pcie_ed.v"                                                                  "$QSYS_SIMDIR/pcie_ed.v"                                                                                                           
    return $design_files
  }
  
  proc get_non_duplicate_elab_option {ELAB_OPTIONS NEW_ELAB_OPTION} {
    set IS_DUPLICATE [string first $NEW_ELAB_OPTION $ELAB_OPTIONS]
    if {$IS_DUPLICATE == -1} {
      return $NEW_ELAB_OPTION
    } else {
      return ""
    }
  }
  
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_resetIP::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_MEM0::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_DMA_CONTROLLER::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_dut::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_BAR_INTERPRETER::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    append SIM_OPTIONS [pcie_ed_resetIP::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_MEM0::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_DMA_CONTROLLER::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_dut::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_BAR_INTERPRETER::get_sim_options $SIMULATOR_TOOL_BITNESS]
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_resetIP::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_MEM0::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_DMA_CONTROLLER::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_dut::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_BAR_INTERPRETER::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc get_dpi_libraries {QSYS_SIMDIR} {
    set libraries [dict create]
    set libraries [dict merge $libraries [pcie_ed_resetIP::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_MEM0::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_DMA_CONTROLLER::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_dut::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_BAR_INTERPRETER::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/"]]
    
    return $libraries
  }
  
}
