source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_resetIP/sim/common/xcelium_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_MEM0/sim/common/xcelium_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/common/xcelium_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_dut/sim/common/xcelium_files.tcl]
source [file join [file dirname [info script]] ./../../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/common/xcelium_files.tcl]

namespace eval pcie_ed {
  proc get_design_libraries {} {
    set libraries [dict create]
    set libraries [dict merge $libraries [pcie_ed_resetIP::get_design_libraries]]
    set libraries [dict merge $libraries [pcie_ed_MEM0::get_design_libraries]]
    set libraries [dict merge $libraries [pcie_ed_DMA_CONTROLLER::get_design_libraries]]
    set libraries [dict merge $libraries [pcie_ed_dut::get_design_libraries]]
    set libraries [dict merge $libraries [pcie_ed_BAR_INTERPRETER::get_design_libraries]]
    dict set libraries altera_merlin_master_translator_193    1
    dict set libraries altera_merlin_slave_translator_191     1
    dict set libraries altera_merlin_master_agent_1931        1
    dict set libraries altera_merlin_slave_agent_1930         1
    dict set libraries altera_avalon_sc_fifo_1932             1
    dict set libraries altera_merlin_router_1921              1
    dict set libraries altera_merlin_traffic_limiter_1921     1
    dict set libraries altera_merlin_demultiplexer_1921       1
    dict set libraries altera_merlin_multiplexer_1922         1
    dict set libraries altera_merlin_waitrequest_adapter_1912 1
    dict set libraries altera_avalon_st_pipeline_stage_1930   1
    dict set libraries altera_mm_interconnect_1920            1
    dict set libraries pcie_ed                                1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set memory_files [list]
    set memory_files [concat $memory_files [pcie_ed_resetIP::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_MEM0::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_DMA_CONTROLLER::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_dut::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/" "$QUARTUS_INSTALL_DIR"]]
    set memory_files [concat $memory_files [pcie_ed_BAR_INTERPRETER::get_memory_files "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/" "$QUARTUS_INSTALL_DIR"]]
    return $memory_files
  }
  
  proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [dict create]
    set design_files [dict merge $design_files [pcie_ed_resetIP::get_common_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_MEM0::get_common_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_DMA_CONTROLLER::get_common_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_dut::get_common_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/"]]
    set design_files [dict merge $design_files [pcie_ed_BAR_INTERPRETER::get_common_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/"]]
    return $design_files
  }
  
  proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR QUARTUS_INSTALL_DIR} {
    set design_files [list]
    set design_files [concat $design_files [pcie_ed_resetIP::get_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [concat $design_files [pcie_ed_MEM0::get_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [concat $design_files [pcie_ed_DMA_CONTROLLER::get_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [concat $design_files [pcie_ed_dut::get_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/" "$QUARTUS_INSTALL_DIR"]]
    set design_files [concat $design_files [pcie_ed_BAR_INTERPRETER::get_design_files $USER_DEFINED_COMPILE_OPTIONS $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_VHDL_COMPILE_OPTIONS "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/" "$QUARTUS_INSTALL_DIR"]]
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_gqdbrbq.sv\"  -work altera_merlin_master_translator_193 -cdslib  ./cds_libs/altera_merlin_master_translator_193.cds.lib"    
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_hjlcphy.sv\"  -work altera_merlin_master_translator_193 -cdslib  ./cds_libs/altera_merlin_master_translator_193.cds.lib"    
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_slave_translator_191/sim/pcie_ed_altera_merlin_slave_translator_191_xg7rzxi.sv\"  -work altera_merlin_slave_translator_191 -cdslib  ./cds_libs/altera_merlin_slave_translator_191.cds.lib"        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_master_agent_1931/sim/pcie_ed_altera_merlin_master_agent_1931_56t3lmi.sv\"  -work altera_merlin_master_agent_1931 -cdslib  ./cds_libs/altera_merlin_master_agent_1931.cds.lib"                    
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_slave_agent_1930/sim/pcie_ed_altera_merlin_slave_agent_1930_jxauz3i.sv\"  -work altera_merlin_slave_agent_1930 -cdslib  ./cds_libs/altera_merlin_slave_agent_1930.cds.lib"                        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_slave_agent_1930/sim/altera_merlin_burst_uncompressor.sv\"  -work altera_merlin_slave_agent_1930 -cdslib  ./cds_libs/altera_merlin_slave_agent_1930.cds.lib"                                      
    lappend design_files "xmvlog -zlib 1 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_avalon_sc_fifo_1932/sim/pcie_ed_altera_avalon_sc_fifo_1932_22gxxgi.v\"  -work altera_avalon_sc_fifo_1932 -cdslib  ./cds_libs/altera_avalon_sc_fifo_1932.cds.lib"                                             
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_r4umyza.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_tuh65mq.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_p35amvi.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -compcnfg $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/pcie_ed_altera_merlin_traffic_limiter_altera_avalon_sc_fifo_1921_ctvx6xa.v\"  -work altera_merlin_traffic_limiter_1921"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/altera_merlin_reorder_memory.sv\"  -work altera_merlin_traffic_limiter_1921 -cdslib  ./cds_libs/altera_merlin_traffic_limiter_1921.cds.lib"                              
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/altera_avalon_st_pipeline_base.v\"  -work altera_merlin_traffic_limiter_1921 -cdslib  ./cds_libs/altera_merlin_traffic_limiter_1921.cds.lib"                             
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_traffic_limiter_1921/sim/pcie_ed_altera_merlin_traffic_limiter_1921_etfmhbi.sv\"  -work altera_merlin_traffic_limiter_1921 -cdslib  ./cds_libs/altera_merlin_traffic_limiter_1921.cds.lib"        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/pcie_ed_altera_merlin_demultiplexer_1921_43wbivq.sv\"  -work altera_merlin_demultiplexer_1921 -cdslib  ./cds_libs/altera_merlin_demultiplexer_1921.cds.lib"                
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_qq2xwja.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                                              
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_xauqp4i.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                                              
    lappend design_files "xmvlog -zlib 1 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_waitrequest_adapter_1912/sim/altera_merlin_waitrequest_adapter.v\"  -work altera_merlin_waitrequest_adapter_1912 -cdslib  ./cds_libs/altera_merlin_waitrequest_adapter_1912.cds.lib"                  
    lappend design_files "xmvlog -zlib 1 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_waitrequest_adapter_1912/sim/altera_avalon_sc_fifo.v\"  -work altera_merlin_waitrequest_adapter_1912 -cdslib  ./cds_libs/altera_merlin_waitrequest_adapter_1912.cds.lib"                              
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_avalon_st_pipeline_stage_1930/sim/pcie_ed_altera_avalon_st_pipeline_stage_1930_oiupeiq.sv\"  -work altera_avalon_st_pipeline_stage_1930 -cdslib  ./cds_libs/altera_avalon_st_pipeline_stage_1930.cds.lib"
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_avalon_st_pipeline_stage_1930/sim/altera_avalon_st_pipeline_base.v\"  -work altera_avalon_st_pipeline_stage_1930 -cdslib  ./cds_libs/altera_avalon_st_pipeline_stage_1930.cds.lib"                       
    lappend design_files "xmvlog -zlib 1 -compcnfg $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_tfv2hfa.v\"  -work altera_mm_interconnect_1920"                                                                                       
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_lgcew2q.sv\"  -work altera_merlin_master_translator_193 -cdslib  ./cds_libs/altera_merlin_master_translator_193.cds.lib"    
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_j2lddiy.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_yopg3ma.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/pcie_ed_altera_merlin_demultiplexer_1921_msxwozy.sv\"  -work altera_merlin_demultiplexer_1921 -cdslib  ./cds_libs/altera_merlin_demultiplexer_1921.cds.lib"                
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_bo7umjy.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                                              
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/pcie_ed_altera_merlin_multiplexer_1922_svo354y.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                        
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_multiplexer_1922/sim/altera_merlin_arbitrator.sv\"  -work altera_merlin_multiplexer_1922 -cdslib  ./cds_libs/altera_merlin_multiplexer_1922.cds.lib"                                              
    lappend design_files "xmvlog -zlib 1 -compcnfg $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_b4k4ufq.v\"  -work altera_mm_interconnect_1920"                                                                                       
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_master_translator_193/sim/pcie_ed_altera_merlin_master_translator_193_j7dnv4i.sv\"  -work altera_merlin_master_translator_193 -cdslib  ./cds_libs/altera_merlin_master_translator_193.cds.lib"    
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_xx4nuzi.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_merlin_router_1921/sim/pcie_ed_altera_merlin_router_1921_2tuydyy.sv\"  -work altera_merlin_router_1921 -cdslib  ./cds_libs/altera_merlin_router_1921.cds.lib"                                            
    lappend design_files "xmvlog -zlib 1 -compcnfg $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/pcie_ed_altera_mm_interconnect_1920_jn5blyq.v\"  -work altera_mm_interconnect_1920"                                                                                       
    lappend design_files "xmvlog -zlib 1 -compcnfg $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"$QSYS_SIMDIR/pcie_ed.v\"  -work pcie_ed"                                                                                                                                                                                  
    return $design_files
  }
  
  proc get_non_duplicate_elab_option {ELAB_OPTIONS NEW_ELAB_OPTION} {
    set IS_DUPLICATE [string first $NEW_ELAB_OPTION $ELAB_OPTIONS]
    if {$IS_DUPLICATE == -1} {
      return $NEW_ELAB_OPTION
    } else {
      return ""
    }
  }
  
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_resetIP::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_MEM0::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_DMA_CONTROLLER::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_dut::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    append ELAB_OPTIONS [get_non_duplicate_elab_option $ELAB_OPTIONS [pcie_ed_BAR_INTERPRETER::get_elab_options $SIMULATOR_TOOL_BITNESS]]
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    append SIM_OPTIONS [pcie_ed_resetIP::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_MEM0::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_DMA_CONTROLLER::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_dut::get_sim_options $SIMULATOR_TOOL_BITNESS]
    append SIM_OPTIONS [pcie_ed_BAR_INTERPRETER::get_sim_options $SIMULATOR_TOOL_BITNESS]
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_resetIP::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_MEM0::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_DMA_CONTROLLER::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_dut::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    set LD_LIBRARY_PATH [dict merge $LD_LIBRARY_PATH [dict get [pcie_ed_BAR_INTERPRETER::get_env_variables $SIMULATOR_TOOL_BITNESS] "LD_LIBRARY_PATH"]]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc get_dpi_libraries {QSYS_SIMDIR} {
    set libraries [dict create]
    set libraries [dict merge $libraries [pcie_ed_resetIP::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_resetIP/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_MEM0::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_MEM0/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_DMA_CONTROLLER::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_DMA_CONTROLLER/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_dut::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_dut/sim/"]]
    set libraries [dict merge $libraries [pcie_ed_BAR_INTERPRETER::get_dpi_libraries "$QSYS_SIMDIR/../../ip/pcie_ed/pcie_ed_BAR_INTERPRETER/sim/"]]
    
    return $libraries
  }
  
}
