/*******************************************************************************
* Copyright (C) 2001-2025 Altera Corporation
*
* This code and the related documents are Altera copyrighted materials and
* your use of them is governed by the express license under which they were
* provided to you ("License"). Unless the License provides otherwise, you may
* not use, modify, copy, publish, distribute, disclose, or transmit this
* code or the related documents without Altera's prior written permission.
* 
* This code and the related documents are provided as is, with no express
* or implied warranties other than those that are expressly stated in the
* License.
* 
*******************************************************************************/


/*
This module is to interconnect XCVR user FIFO in Qsys platform
*/
module  xcvr_user_tx_fifo_converter(
		output   reg  [63:0]  data_pattern_generator_pattern_out               ,     // interconnections
		input    wire         data_pattern_generator_pattern_out_clk           ,     // interconnections
		input    wire         data_pattern_generator_pattern_out_fifo_write_clk,     // interconnections
		input    wire [127:0] data_pattern_generator_pattern_out_fifo_write    ,     // interconnections
		output   reg          data_pattern_generator_tx_fifo_rdempty           ,     // interconnections
		output   reg          data_pattern_generator_tx_fifo_wrfull            ,     // interconnections
    output   reg  [127:0] data        ,   //  fifo_input.datain
    output   reg          wrreq       ,   //            .wrreq
    output   reg          rdreq       ,   //            .rdreq
    output   wire         wrclk       ,   //            .wrclk
    output   wire         rdclk       ,   //            .rdclk
    input    wire [63:0]  q           ,   // fifo_output.dataout
    input    wire         rdempty     ,   //            .rdempty
    input    wire         wrfull          //            .wrfull
);
//    assign       data = data_pattern_generator_pattern_out_fifo_write;
//    assign       wrreq = 1'b1;
//    assign       rdreq = 1'b1;
    assign       wrclk = data_pattern_generator_pattern_out_fifo_write_clk;
    assign       rdclk = data_pattern_generator_pattern_out_clk;
//    assign       data_pattern_generator_pattern_out     = q      ;
//    assign       data_pattern_generator_tx_fifo_rdempty = rdempty;
//    assign       data_pattern_generator_tx_fifo_wrfull  = wrfull ;
reg  [63:0] reg1_data_pattern_generator_pattern_out     ;
reg         reg1_data_pattern_generator_tx_fifo_rdempty ;
reg         reg1_rdreq                                  ;
reg  [127:0] reg1_data                                   ;
reg          reg1_wrreq                                  ;
reg          reg1_data_pattern_generator_tx_fifo_wrfull  ;
//to use hyper register to improve the timing, 
always @ (posedge data_pattern_generator_pattern_out_clk)
begin
reg1_data_pattern_generator_pattern_out     <= q        ;
reg1_data_pattern_generator_tx_fifo_rdempty <= rdempty  ;
reg1_rdreq                                  <= 1'b1     ;
data_pattern_generator_pattern_out     <= reg1_data_pattern_generator_pattern_out     ;
data_pattern_generator_tx_fifo_rdempty <= reg1_data_pattern_generator_tx_fifo_rdempty ;
rdreq                                  <= reg1_rdreq                                  ;
end
always @ (posedge data_pattern_generator_pattern_out_fifo_write_clk)
begin
reg1_data                                   <= data_pattern_generator_pattern_out_fifo_write  ;
reg1_wrreq                                  <= 1'b1                                           ;
reg1_data_pattern_generator_tx_fifo_wrfull  <= wrfull                                         ;
	
	
data                                   <= reg1_data                                   ;
wrreq                                  <= reg1_wrreq                                  ;
data_pattern_generator_tx_fifo_wrfull  <= reg1_data_pattern_generator_tx_fifo_wrfull  ;
end
endmodule
